from mechanize import Browser
from lxml import etree
import sys
import cookielib
import os
import xml.etree.ElementTree

def check_syntax(html, parser, lineno, save_anyway = None):
    try:
        tree = etree.XML(html, parser)
        if save_anyway:
            f = open(save_anyway, "w")
            f.write(html)
            f.close()
        return True
    except Exception as inst:
        print "HTML file obtained in line %d does not pass HTML validation, saved in file errors/error.%d.html" %(lineno, lineno)
        f = open("errors/error.%d.html" %lineno, "w")
        f.write(html)
        f.close()
        print "Error explanation: " + str(inst)
        return False

def xml_modify_rec(root, tag, value):
    if len(root) == 2:
        for i in [0, 1]:
            if root[i].tag == "param-name" and root[i].text == tag:
                root[(i + 1)%2].text = value
                return
    for child in root:
        xml_modify_rec(child, tag, value)

def xml_modify(xml_file, tag, value):
    root = xml.etree.ElementTree.parse(xml_file).getroot()
    xml_modify_rec(root, tag, value)
    content = xml.etree.ElementTree.tostring(root)
    f = open(xml_file, "w")
    f.write(content)
    f.close()
    
try:
    f = open("test.txt", "r")
except Exception as ex:
    print "Unable to open file test.txt because: " + str(ex)
    sys.exit(1)
test = f.readlines()
f.close()
parser = etree.XMLParser(ns_clean=True)
br = Browser()
cj = cookielib.CookieJar()
br.set_cookiejar(cj)
lineno = 0
curr_test_passed = True
total_points = 0
points = 0
try:
    for line in test:
        lineno += 1
        if line[0] == '#':
            continue
        line = line.replace("\n", "")
        line_ar = line.split("|")
        if line_ar[0] == "test_passed":
            if curr_test_passed:
                points += int(line_ar[1])
            total_points += int(line_ar[1])
            curr_test_passed = True
        elif curr_test_passed:
            if line_ar[0] == "copy":
                filename = os.path.join(*(line_ar[1].split("/")))
                try:
                    f = open(filename, "r")
                except Exception as ex:
                    print "Unable to open file " + line_ar[1] + " because: " + str(ex)
                    sys.exit(1)
                content = f.read()
                f.close()
                filename = os.path.join(*(line_ar[2].split("/")))
                try:
                    f = open(filename, "w")
                except Exception as ex:
                    print "Unable to open file " + line_ar[2] + " because: " + str(ex)
                    sys.exit(1)
                f.write(content)
                f.close()
            elif line_ar[0] == "open":
                response = br.open(line_ar[1])
                curr_test_passed = check_syntax(response.get_data(), parser, lineno) and curr_test_passed
            elif line_ar[0] == "form":
                br.select_form(line_ar[1])
                inputs = {}
                for opt in line_ar[3:]:
                    if opt[0] != '"':
                        multiple = (opt[-1] == "+")
                        opt = opt[:-1]
                        inputs[opt] = [multiple, []]
                        last = opt
                    else:
                        inputs[last][1] += [opt[1:-1]]
                for name in inputs:
                    br[name] = inputs[name][1][0] if not(inputs[name][0]) else inputs[name][1]
                if line_ar[2] != "":
                    response = br.submit(line_ar[2])
                else:
                    response = br.submit()
                curr_test_passed = check_syntax(response.get_data(), parser, lineno) and curr_test_passed
            elif line_ar[0] == "link":
                req = br.click_link(name=line_ar[1])
                response = br.open(req)
                curr_test_passed = check_syntax(response.get_data(), parser, lineno) and curr_test_passed
            elif line_ar[0] == "save":
                filename = os.path.join(*(line_ar[1].split("/")))
                try:
                    f = open(filename, "w")
                except Exception as ex:
                    print "Unable to open file " + line_ar[1] + " because: " + str(ex)
                    sys.exit(1)
                f.write(response.get_data())
                f.close()
            elif line_ar[0] == "clear_cookies":
                cj.clear()
            elif line_ar[0] == "check_present":
                indexes = [response.get_data().find(item) for item in line_ar[1:]]
                indexes_sort = indexes[:]
                indexes_sort.sort()
                if indexes[:] != indexes_sort[:] or indexes_sort[0] == -1:
                    print "HTML file obtained in line %d does not pass check_present, saved in file errors/error.%d.html" %(lineno, lineno)
                    filename = "errors/error.%d.html" %lineno
                    f = open(filename, "w")
                    f.write("<!--Strings searched: %s-->\n" %str(line_ar[1:]))
                    f.write("<!--Indexes: %s-->\n" %str(indexes))
                    f.write(response.get_data())
                    f.close()
                    curr_test_passed = False
            elif line_ar[0] == "check_not_present":
                indexes = [response.get_data().find(item) for item in line_ar[1:]]
                if set(indexes) != set([-1]):
                    print "HTML file obtained in line %d does not pass check_not_present, saved in file errors/error.%d.html" %(lineno, lineno)
                    filename = "errors/error.%d.html" %lineno
                    f = open(filename, "w")
                    f.write("<!--Strings searched: %s-->\n" %str(line_ar[1:]))
                    f.write("<!--Indexes: %s-->\n" %str(indexes))
                    f.write(response.get_data())
                    f.close()
                    curr_test_passed = False
            elif line_ar[0] == "block_cookies":
                # pol = cookielib.DefaultCookiePolicy()
                # pol.set_blocked_domains([line_ar[1]])
                # cj.set_policy(pol)
                cj.set_policy(cookielib.DefaultCookiePolicy(rfc2965=True, strict_ns_domain=cookielib.DefaultCookiePolicy.DomainStrict, allowed_domains=["out.com"]))
            elif line_ar[0] == "allow_cookies":
                # pol = cookielib.DefaultCookiePolicy()
                # pol.set_blocked_domains([])
                # cj.set_policy(pol)
                cj.set_policy(cookielib.DefaultCookiePolicy(rfc2965=True, strict_ns_domain=cookielib.DefaultCookiePolicy.DomainStrict, allowed_domains=None))
            elif line_ar[0] == "reload":
                br_man = Browser()
                cj_man = cookielib.CookieJar()
                br_man.set_cookiejar(cj_man)
                br_man.add_password('http://localhost:8080/manager/html/', login_manager, password_manager)
                response_man = br_man.open("http://localhost:8080/manager/html/")
                lines_man = response_man.get_data().splitlines()
                count_form = -1
                for line_man in lines_man:
                    if line_man.find("<form") != -1:
                        count_form += 1
                    if line_man.find("Reload") != -1 and line_man.find(matricola.replace("_", "%5F")) != -1:
                        break
                br_man.select_form(nr = count_form)
                br_man.submit()
            elif line_ar[0] == "init":
                login_manager = line_ar[1]
                password_manager = line_ar[2]
                matricola = line_ar[3]
            elif line_ar[0] == "xml_modify":
                xml_modify(line_ar[1], line_ar[2], line_ar[3])
    print "\n\nPROJECT EVALUATION: " + str(points) + "/" + str(total_points)
except Exception as ex:
    print "something went wrong at line %d: %s" %(lineno, str(ex))
